<template>
  <div>
    <div class="anon-auth-modal__row">
      <ob-input
        v-model="auth.username"
        type="email"
        placeholder="Электронная почта"
        label="Адрес электронной почты"
        @input="resetError"
      />
    </div>

    <div class="anon-auth-modal__row">
      <ob-input
        v-model="auth.password"
        :type="isPasswordVisible ? 'text' : 'password'"
        placeholder="Пароль"
        label="Введите пароль"
        @input="resetError"
      />
      <div class="show-pwd-icon">
        <i
          :class="['icon', isPasswordVisible ? 'blind-auction' : 'profile-eye']"
          @click="togglePassword"
          :title="isPasswordVisible ? 'Скрыть пароль' : 'Показать пароль'"
        ></i>
      </div>
    </div>

    <div class="anon-auth-modal__row" v-if="error.message.length">
      <!-- <infoPanel :message="error.message" :panelType="error.type" /> -->
      <obAlert icon="info" :text="error.message" :theme="error.type" hideCloseButton />
    </div>

    <div class="anon-auth-modal__row anon-button">
      <ob-button
        label="Войти"
        :isFullWidth="true"
        @click="onLogin"
        :disabled="
          !auth.username.length ||
          !auth.password.length ||
          !!error.message.length ||
          !isFormDirty
        "
      />
    </div>

    <div class="anon-auth-modal__row anon-recover">
      <span @click="onRedirect('restore')">Не помню пароль</span>
    </div>

    <div class="anon-auth-modal__row anon-link">
      Нет аккаунта?
      <span @click="onRedirect('signup')">Зарегистрироваться</span>
    </div>

    <div class="busy" v-if="isLoading">
      <ob-loader/>
    </div>
  </div>
</template>

<script>
import api from "@/api";
import jwtDecode from "jwt-decode";
import { mapMutations, mapActions } from "vuex";
import VueCookie from 'vue-cookie'
import obInput from "common-components/src/obComponents/obInput";
import obButton from "common-components/src/obComponents/obButton";
import obLoader from 'common-components/src/obComponents/obLoader';
import obAlert from 'common-components/src/obComponents/obAlert';
export default {
  name: "authModal",

  components: {
    obInput,
    obButton,
    obLoader,
    obAlert
  },

  data() {
    return {
      auth: {
        username: "",
        password: "",
      },
      error: {
        type: "",
        message: "",
      },
      bak: "{}",
      isFormDirty: false,
      isPasswordVisible: false,
      isLoading: false
    };
  },

  watch: {
    auth: {
      handler: function (newVal) {
        if (JSON.stringify(newVal) !== this.bak) {
          this.isFormDirty = true;
        }
      },
      immediate: true,
      deep: true,
    },
  },

  methods: {
    ...mapActions({
      fetchMenu: 'functions/fetchMenu'
    }),
    ...mapMutations({
      setTokenData: 'user/setTokenData'
    }),
    togglePassword() {
      this.isPasswordVisible = !this.isPasswordVisible;
    },

    resetError() {
      this.error.type = "";
      this.error.message = "";
    },
    async onLogin() {
      this.isLoading = true;
      this.bak = JSON.stringify(this.auth);
      try {
        const data = await api.registration.auth.login(this.auth);
        const token = data.token;
        const refreshToken = data.refreshToken
        const { contractor_role_code } = jwtDecode(token);
        if (contractor_role_code !== "client") {
          this.error.type = "warning";
          this.error.message = "Вы не можете размещать заказы";
          this.isLoading = false;
          return
        } else {
          VueCookie.set('auth_token', token)
          VueCookie.set('refresh_token', refreshToken)
          this.setTokenData();
          await this.fetchMenu();
        }
      } catch (err) {
        this.isLoading = false;
        console.error(err);
        this.error.type = "danger";
        this.error.message = "Неверный логин или пароль";
        return
      }

      try {
          await api.orders.RelocationFromAnonymous(this.$route.params.id);
          await api.orders.changeOrderStatus(this.$route.params.id, "FORMED");
        if (window.dataLayer) {
          window.dataLayer.push({event: 'guest_order_formed'})
        }
          this.$router.push(`/order-drafts-item/${this.$route.params.id}`, () => { this.$router.go(0) });
      } catch (err) {
        console.error(err);
      }
    },

    onRedirect(direction) {
      VueCookie.delete('auth_token');
      VueCookie.delete('refresh_token');
      this.$router.push(`/${direction}`);
    }
  },
};
</script>

<style lang="scss" scoped>
.anon-auth-modal__row {
  margin-top: 20px;
  position: relative;
}

.anon-button,
.anon-recover {
  margin-top: 30px;
  text-align: center;
}

.anon-link {
  margin-top: 40px;
  text-align: center;
}
span {
  color: #0070a6;
  cursor: pointer;
}

.show-pwd-icon {
  position: absolute;
  top: 50%;
  margin-top: -10px;
  right: 10px;
  font-size: 20px;

  .icon {
    transition: all 0.3s ease-in-out;
  }
}

.busy {
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  background-color: $obAutocomplete-results_loading_block_background;

  .preloader {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-20px, -20px);
  }
}
</style>